IncludeFile "includes/cv_functions.pbi"

Global getCV.b, *save.IplImage, exitCV.b, lpPrevWndFunc

#CV_WINDOW_NAME = "PureBasic Interface to OpenCV"
#CV_DESCRIPTION = "Find traffic speed sign"

ProcedureC WindowCallback(hWnd, Msg, wParam, lParam)
  Select Msg
    Case #WM_COMMAND
      Select wParam
        Case 1
          getCV = #True
          keybd_event_(#VK_ESCAPE, 0, 0, 0)
        Case 2
          FileName.s = SaveFile()

          If FileName
            params.SAVE_INFO

            Select LCase(GetExtensionPart(FileName))
              Case "jpeg", "jpg", "jpe"
                params\paramId = #CV_IMWRITE_JPEG_QUALITY
                params\paramValue = 95
              Case "png"
                params\paramId = #CV_IMWRITE_PNG_COMPRESSION
                params\paramValue = 3
              Case "ppm", "pgm", "pbm"
                params\paramId = #CV_IMWRITE_PXM_BINARY
                params\paramValue = 1
              Default
                Select SelectedFilePattern()
                  Case 0
                    FileName + ".jpg"
                    params\paramId = #CV_IMWRITE_JPEG_QUALITY
                    params\paramValue = 95
                  Case 1
                    FileName + ".png"
                    params\paramId = #CV_IMWRITE_PNG_COMPRESSION
                    params\paramValue = 3
                  Case 2
                    FileName + ".ppm"
                    params\paramId = #CV_IMWRITE_PXM_BINARY
                    params\paramValue = 1
                EndSelect
            EndSelect
            cvSaveImage(FileName, *save, @params)
          EndIf
        Case 10
          keybd_event_(#VK_ESCAPE, 0, 0, 0)
      EndSelect
    Case #WM_DESTROY
      exitCV = #True
  EndSelect
  ProcedureReturn CallWindowProc_(lpPrevWndFunc, hWnd, Msg, wParam, lParam)
EndProcedure

ProcedureC CvMouseCallback(event, x, y, flags, *param.USER_INFO)
  Select event
    Case #CV_EVENT_RBUTTONDOWN
      *save = *param\uPointer1
      DisplayPopupMenu(0, *param\uValue)
  EndSelect
EndProcedure

ProcedureC OpenCV(ImageFile.s)
  If FileSize(ImageFile) > 0
    cvNamedWindow(#CV_WINDOW_NAME, #CV_WINDOW_AUTOSIZE)
    window_handle = cvGetWindowHandle(#CV_WINDOW_NAME)
    *window_name = cvGetWindowName(window_handle)
    lpPrevWndFunc = SetWindowLongPtr_(window_handle, #GWL_WNDPROC, @WindowCallback())

    If CreatePopupImageMenu(0, #PB_Menu_ModernLook)
      MenuItem(1, "Open")
      MenuBar()
      MenuItem(2, "Save")
      MenuBar()
      MenuItem(10, "Exit")
    EndIf
    hWnd = GetParent_(window_handle)
    opencv = LoadImage_(GetModuleHandle_(0), @"icons/opencv.ico", #IMAGE_ICON, 35, 32, #LR_LOADFROMFILE)
    SendMessage_(hWnd, #WM_SETICON, 0, opencv)
    wStyle = GetWindowLongPtr_(hWnd, #GWL_STYLE)
    SetWindowLongPtr_(hWnd, #GWL_STYLE, wStyle & ~(#WS_MAXIMIZEBOX | #WS_MINIMIZEBOX | #WS_SIZEBOX))
    *image.IplImage = cvLoadImage(ImageFile, #CV_LOAD_IMAGE_ANYDEPTH | #CV_LOAD_IMAGE_ANYCOLOR)
    dtWidth = DesktopWidth(0)
    dtHeight = DesktopHeight(0)

    If *image\width >= dtWidth - 100 Or *image\height >= dtHeight - 100
      iWidth = dtWidth - 100
      iRatio1.d = iWidth / *image\width
      iHeight = dtHeight - 100
      iRatio2.d = iHeight / *image\height

      If iRatio1 < iRatio2
        iWidth = *image\width * iRatio1
        iHeight = *image\height * iRatio1
      Else
        iWidth = *image\width * iRatio2
        iHeight = *image\height * iRatio2
      EndIf
      cvResizeWindow(#CV_WINDOW_NAME, iWidth, iHeight)
      *resize.IplImage = cvCreateImage(iWidth, iHeight, #IPL_DEPTH_8U, *image\nChannels)
      cvResize(*image, *resize, #CV_INTER_AREA)
    Else
      cvResizeWindow(#CV_WINDOW_NAME, *image\width, *image\height)
      *resize.IplImage = cvCloneImage(*image)
    EndIf
    cvMoveWindow(#CV_WINDOW_NAME, 20, 20)
    ToolTip(window_handle, #CV_DESCRIPTION)

    If *resize\width > 200 And *resize\height > 200 And *resize\nChannels = 3
      *dst0.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)
      *dst1.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)      
      *dst2.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)     
      *diff.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)
      *mask.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)
      *dst2mask.IplImage = cvCreateImage(*resize\width, *resize\height, #IPL_DEPTH_8U, 1)
      cvSet(*mask, 0, 0, 0, 0, #Null)      
      cvSplit(*resize, *dst0, *dst1, *dst2, #Null)            
      cvAbsDiff(*dst1, *dst2, *diff)         
      comp.CvConnectedComp 
      cvFloodFill(*diff, 2, 2, 255, 0, 0, 0, 30, 30, 30, 0, 30, 30, 30, 0, @comp, 4 + (255 << 8) + #CV_FLOODFILL_FIXED_RANGE, #Null)              
      cvThreshold(*diff, *diff, 60, 255, #CV_THRESH_BINARY_INV)               
      *storage.CvMemStorage = cvCreateMemStorage(0)
      cvClearMemStorage(*storage)
      *contours.CvContour
      nContours = cvFindContours(*diff, *storage, @*contours, SizeOf(CvContour), #CV_RETR_EXTERNAL, #CV_CHAIN_APPROX_SIMPLE, 0, 0)        
      If nContours
        For rtnCount = 0 To nContours - 1
          area.d = cvContourArea(*contours, 0, #CV_WHOLE_SEQ_END_INDEX, 0)
          If area >= 300 And area <= 30000          
            perim.d = cvArcLength(*contours, 0, #CV_WHOLE_SEQ_END_INDEX, 1)
            ratio.d = perim*perim/(4*#PI*area)               
            If ratio > 1.0 And ratio < 1.2                            
              cvEllipse(*mask, *contours\rect\x+(*contours\rect\width/2),*contours\rect\y+(*contours\rect\height/2), *contours\rect\width/2-(*contours\rect\width/16), *contours\rect\height/2-(*contours\rect\height/16), 0, 0, 360, 255, 255, 255, 0, #CV_FILLED, #CV_AA, 0)                             
            EndIf           
          EndIf            
          *contours = *contours\h_next
        Next      
      EndIf          
      cvCopy(*dst2, *dst2mask, *mask) 
      comp.CvConnectedComp      
      cvFloodFill(*dst2mask, 2, 2, 255, 0, 0, 0, 20, 20, 20, 0, 20, 20, 20, 0, @comp, 4 + (255 << 8) + #CV_FLOODFILL_FIXED_RANGE, #Null)              
      cvThreshold(*dst2mask, *dst2mask, 150, 255, #CV_THRESH_BINARY_INV)                        
      cvClearMemStorage(*storage)
      nContours = cvFindContours(*dst2mask, *storage, @*contours, SizeOf(CvContour), #CV_RETR_EXTERNAL, #CV_CHAIN_APPROX_NONE, 0, 0)      
      For rtnCount = 0 To nContours - 1      
        area.d = cvContourArea(*contours, 0, #CV_WHOLE_SEQ_END_INDEX, 0)
        If area >= 5 ;And area <= 3000        
          cvRectangleR(*resize, *contours\rect\x-1, *contours\rect\y-1, *contours\rect\width+1, *contours\rect\height+1, 255, 20, 25, 0, 1, #CV_AA, #Null)
        EndIf
        *contours = *contours\h_next
      Next      
      *param.USER_INFO = AllocateMemory(SizeOf(USER_INFO))
      *param\uPointer1 = *resize
      *param\uValue = window_handle
      cvSetMouseCallback(*window_name, @CvMouseCallback(), *param)
      Repeat
        If *resize
          cvShowImage(#CV_WINDOW_NAME, *resize)
          keyPressed = cvWaitKey(0)
        EndIf
      Until keyPressed = 27 Or exitCV
      FreeMemory(*param)
      cvReleaseImage(@*dst2)
      cvReleaseImage(@*dst1)      
      cvReleaseImage(@*dst0)
      cvReleaseImage(@*resize)
      cvReleaseImage(@*image)
      cvReleaseImage(@*diff)
      cvReleaseImage(@*diffcopy)
      cvReleaseImage(@*mask)
      cvReleaseImage(@*dst2mask)    
      cvDestroyWindow(#CV_WINDOW_NAME)
      If getCV
        getCV = #False
        exitCV = #False
        OpenCV(GetImage())
      EndIf
    Else
      If *resize\nChannels = 3
        MessageBox_(0, ImageFile + Chr(10) + Chr(10) + "... does not meet the size requirements, please try a larger image.", #CV_WINDOW_NAME, #MB_ICONERROR)
      Else
        MessageBox_(0, ImageFile + Chr(10) + Chr(10) + "... does not meet the channel requirements, please try a color image.", #CV_WINDOW_NAME, #MB_ICONERROR)
      EndIf
      cvReleaseImage(@*resize)
      cvReleaseImage(@*image)
      cvDestroyWindow(#CV_WINDOW_NAME)
      exitCV = #False
      OpenCV(GetImage())
    EndIf
  Else
    MessageBox_(0, "File "+ImageFile + Chr(10) + Chr(10) +"not found, specify right path, please.", #CV_WINDOW_NAME, #MB_ICONERROR)
  EndIf
EndProcedure

ExamineDesktops()
OpenCV("d:\SpeedSigns\40.jpg")
; OpenCV("d:\SpeedSigns\50.jpg")
; OpenCV("d:\SpeedSigns\60.jpg")
; OpenCV("d:\SpeedSigns\70.jpg")
; OpenCV("d:\SpeedSigns\80.jpg")
; OpenCV("d:\SpeedSigns\90.jpg")
; OpenCV("d:\SpeedSigns\100.jpg")
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 200
; FirstLine = 159
; Folding = -
; EnableXP
; CurrentDirectory = binaries\